\section{The ten Tusscher cell model}
\label{sec:TenTusscher}

In the ventricles, we use the ten Tusscher cell model
\cite{tentusscher}. The model is extended by a stretch-activated
channel based on the formulation in \cite{kohlsachsSAC,taviSAC}.

Here, the model involves the ion concentration of
calcium $\text{Ca}$, $\text{Ca}_\text{SS}$, $\text{Ca}_\text{SR}$,
sodium $\text{Na}$, and potassium $\text{K}$, and 13 gating variables
    \begin{align*}
      w
      =\big(
      \text{Ca},\text{Ca}_\text{SS},\text{Ca}_\text{SR},\text{Na},\text{K},\bar{R}, \bar{O},
      m,h,j,x_\text{r1},x_\text{r2},x_\text{s},s,r,d,f,f_2,f_\text{Ca}\big)
    \end{align*}
and depending on the constants  
$R$, $T$, $F$, $z$, $\text{Na}_\text{e}$, $\text{K}_\text{e}$, $\text{Ca}_\text{e}$,
$G_\text{Na}$, $G_\text{CaL}$, $G_\text{Ks}$, $G_\text{to}$, $G_\text{Kr}$,
$G_\text{K1}$, $G_\text{pCa}$, $G_\text{pK}$, $G_\text{bNa}$, $G_\text{SAC}$,
$p_\text{KNa}$, $V_\text{m,CaL}$, $V_\text{m,pK,1}$ , $V_\text{m,pK,1}$,
$k_\text{NaCa}$, $\gamma$, $\alpha$, $\text{K}_{\text{mNa}_i}$, 
$\text{K}_\text{mCa}$, $k_\text{sat}$, $P_\text{NaK}$, $\text{K}_\text{mK}$,
$\text{K}_\text{mNa}$, $\text{K}_\text{pCa}$, 
$E_\text{SAC}$, $\kappa_\text{e}$ and $\alpha_\text{SAC}$ for ionic currents and the constants
$V_\text{c}$, $V_\text{SR}$, $V_\text{SS}$, $V_\text{leak}$, 
 $V_\text{maxup}$, $K_\text{up}$, $V_\text{rel}$, $V_\text{xfer}$, $k_1$,  $k_2$, $k_3$, $k_4$,
for the evolution of ion
concentration all specified in Tab.~\ref{tab:TenTusscher}.

In the equation for the potential
$ C_\text{m} \partial_t V_\text{m}=   I_\text{ion}(V_\text{m},w,\gamma_{\vec f}) + I_\text{ext}$,
the transmembrane current density $I_\text{ion}$ is given by
    \begin{align*}
      I_\text{ion}(V_\text{m},w,\gamma_{\vec f})
      &=
      I_\text{Na}(V_\text{m},\text{Na},m,h,j)
      +I_\text{CaL}(V_\text{m},d,f,f_2,f_\text{Ca},\text{Ca}_\text{SS})
      +I_\text{Ks}(V_\text{m},\text{K},\text{Na},x_\text{s})
      +I_\text{to}(V_\text{m},\text{K},r,s)\\
      &\qquad\qquad
      +I_\text{Kr}(V_\text{m},\text{K},x_\text{r1},x_\text{r2})
      +I_\text{K1}(V_\text{m},\text{K})+I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      +I_\text{NaK}(V_\text{m}, \text{Na})+I_\text{pCa}(\text{Ca})\\
      &\qquad\qquad
      +I_\text{pK}(V_\text{m},\text{K})+I_\text{bCa}(V_\text{m},\text{Ca})
      +I_\text{bNa}(V_\text{m},\text{Na})
      +I_\text{SAC}(V_\text{m},\gamma_{\vec f})
    \end{align*}
combines the contribution of different ions, where


    \begin{align*}
      I_\text{Na}\big(V_\text{m},\text{Na},m,h,j\big)
      &= G_\text{Na}m^3hj\big(V_\text{m}-E_\text{Na}(\text{Na})\big)
      \,,\\
      I_\text{CaL}(V_\text{m},d,f,f_2,f_\text{Ca},\text{Ca}_\text{SS})
      &=
      4\frac{(V_\text{m}-V_\text{m,CaL})F^2}{RT}\frac{0.25\text{Ca}_\text{SS}
        \exp\big(2(V_\text{m}-V_\text{m,CaL})\frac{F}{RT}\big)-\text{Ca}_\text{e}}{\exp\big(2(V_\text{m}-V_\text{m,CaL})
        \frac{F}{RT}\big)-1}
      G_\text{CaL}ff_2f_\text{Ca}d
      \,,\\
      I_\text{Ks}(V_\text{m},\text{K},\text{Na},x_\text{s})
      &=
      G_\text{Ks}x_\text{s}^2\big(V_\text{m}-E_\text{Ks}(\text{K},\text{Na})\big)
      \,,\\
      I_\text{to}(V_\text{m},\text{K},r,s)
      &=
      G_\text{to}rs \big(V_\text{m}-E_\text{K}(\text{K})\big)
      \,,\\
      I_\text{Kr}(V_\text{m},\text{K},x_\text{r1},x_\text{r2})
      &=
      G_\text{Kr}\sqrt{\frac{\text{K}_\text{e}}{5.4}}x_\text{r1}x_\text{r2}
      \big(V_\text{m}-E_\text{K}(\text{K})\big)
      \,,\\
      I_\text{K1}(V_\text{m},\text{K})
      &=
      G_\text{K1}\sqrt{\frac{\text{K}_\text{e}}{5.4}}x_{\text{K1},\infty}(V_\text{m},\text{K})
      \big(V_\text{m}-E_\text{K}(\text{K})\big)
      \,,\\
      I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      &=
      k_\text{NaCa}
      \frac{\exp\big(\gamma V_\text{m} \frac{F}{RT}\big)\text{Na}^3\text{Ca}_\text{e}
        - \exp\big((\gamma-1) V_\text{m} \frac{F}{RT}\big)\text{Na}_\text{e}^3\text{Ca}\alpha}
	   {(\text{K}_{\text{mNa}_i}^3+\text{Na}_\text{e}^3)(\text{K}_\text{mCa}
             +\text{Ca}_\text{e})\big(1+k_\text{sat}
             \exp\big((\gamma-1)V_\text{m}\frac{F}{RT}\big)\big))}      
      \,,\\
      I_\text{NaK}(V_\text{m}, \text{Na})
      &=
      P_\text{NaK}\frac{\text{K}_\text{e}\text{Na}}{(\text{K}_\text{e}+\text{K}_\text{mK})(\text{Na} + \text{K}_\text{mNa})\big(1+0.1245\exp\big(-0.1V_\text{m}\frac{F}{RT}\big)+0.0353\exp\big(-V_\text{m}\frac{F}{RT}\big)\big)}
      \,,\\
      I_\text{pCa}(\text{Ca})
      &=
      G_\text{pCa} \frac{\text{Ca}}{\text{K}_\text{pCa}+\text{Ca}}
      \,,\\
      I_\text{pK}(V_\text{m},\text{K})
      &=
      G_\text{pK} \frac{V_\text{m}-E_\text{K}(\text{K})}{1+\exp\big((V_\text{m,pK,1}-V_\text{m})/V_\text{m,pK,2}\big)}
      \,,\\
      I_\text{bCa}(V_\text{m},\text{Ca})
      &=
      G_\text{bCa}\big(V_\text{m}-E_\text{Ca}(\text{Ca})\big)
      \,,\\
      I_\text{bNa}(V_\text{m},\text{Na})
      &=
      G_\text{bNa}\big(V_\text{m}-E_\text{Na}(\text{Na})\big)
      \,,\\
      I_\text{SAC}(V_\text{m},\gamma_{\vec f})
      &= G_\text{SAC} \frac{V_\text{m} - E_\text{SAC}}{1+\kappa_\text{e}\exp\big(-\alpha_\text{SAC} \gamma_{\vec f})}
    \end{align*}
with the reverse potentials 
    \begin{align*}
      E_\text{Ca}(\text{Ca})
      &= \frac{RT}{zF}\log \frac{\text{Ca}_\text{e}}{\text{Ca}}
      \,,\\
      E_\text{Na}(\text{Na})
      &= \frac{RT}{zF}\log \frac{\text{Na}_\text{e}}{\text{Na}}
      \,,\\
      E_\text{K}(\text{K})
      &= \frac{RT}{zF}\log \frac{\text{K}_\text{e}}{\text{K}}
      \,,\\
      E_\text{Ks}(\text{K},\text{Na})
      &=\frac{RT}{F}\text{log}\frac{\text{K}_\text{e} + p_\text{KNa}\text{Na}_\text{e}}
      {\text{K} + p_\text{KNa}\text{Na}}
      \,,
    \end{align*}
and
     \begin{align*}
       \alpha_\text{K1}(V_\text{m},\text{K})
        &=
        \frac{0.1}{1+\exp\big(0.06(-200+V_\text{m}-E_\text{K}(\text{K}))\big)}
        \,,\\
        \beta_\text{K1}(V_\text{m},\text{K})
        &=
        \frac{3\exp\big(0.0002(100+V_\text{m}-E_\text{K}(\text{K}))\big) +
        	 \exp\big(0.1(-10 + V_\text{m}-E_\text{K}(\text{K}))\big)}
             {1+\exp\big(-0.5(V_\text{m}-E_\text{K}(\text{K}))\big)}
         \,,\\
 	x_{\text{K1},\infty}(V_\text{m},\text{K})
 	&=
        \frac{\alpha_\text{K1}(V_\text{m},\text{K})}{\alpha_\text{K1}(V_\text{m},\text{K})+
          \beta_\text{K1}(V_\text{m},\text{K})}
        \,.
     \end{align*}
For the evolution of ion concentrations and gating variables \eqref{eq:mono2}
we specify every component of $w$ independently.
     
\Paragraph{The evolution of ion concentrations}

We have
    \begin{align*}
      \partial_t \text{Na}
      &= -\frac{1}{V_\text{c}F}
      \Big(
      I_\text{Na}(V_\text{m},\text{Na},m,h,j)
      +I_\text{bNa}(V_\text{m},\text{Na})
      +3I_\text{NaK}(V_\text{m}, \text{Na})
      +3I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      \Big)
      \,,
      \\
      \partial_t \text{K}
      &= -\frac{1}{V_\text{c}F}
      \Big(
      I_\text{K1}(V_\text{m},\text{K})+I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      +I_\text{to}(V_\text{m},\text{K},r,s)
      +I_\text{Kr}(V_\text{m},\text{K},x_\text{r1},x_\text{r2})
      \\
      &\qquad\qquad\qquad
      +I_\text{Ks}(V_\text{m},\text{K},\text{Na},x_\text{s})
      -2I_\text{NaK}(V_\text{m}, \text{Na})
      +I_\text{pCa}(\text{Ca})
      +I_\text{ext}
      \Big)\,,
      \\
      \partial_t \text{Ca}
      &= -\frac{1}{2V_\text{c}F}
      \Big(
      I_\text{bCa}(V_\text{m},\text{Ca})
      +I_\text{pCa}(\text{Ca})
      -2I_\text{NaCa}(V_\text{m},\text{Na},\text{Ca})
      \Big)
      \\
      &\qquad\qquad\qquad
      +\frac{V_\text{SR}}{V_\text{c}}
      \Big(
      I_\text{leak}(\text{Ca},\text{Ca}_\text{SR})
      -I_\text{up}(\text{Ca})
      +I_\text{xfer}(\text{Ca},\text{Ca}_\text{SS})
      \Big)\,,
      \\
      \partial_t \text{Ca}_\text{SR}
      &= 
      I_\text{up}(\text{Ca})
      -I_\text{rel}(\text{Ca}_\text{SR},\text{Ca}_\text{SS},\bar{R})
      -I_\text{leak}(\text{Ca},\text{Ca}_\text{SR})
      \,,
      \\
      \partial_t \text{Ca}_\text{SS}
      &=
      -\frac{1}{2V_\text{SS}F}I_\text{CaL}(V_\text{m},d,f,f_2,f_\text{Ca})
      +\frac{V_\text{SR}}{V_\text{SS}}I_\text{rel}(\text{Ca}_\text{SR},\text{Ca}_\text{SS},\bar{R})
      -\frac{V_\text{C}}{V_\text{SS}}I_\text{xfer}(\text{Ca},\text{Ca}_\text{SS})
    \end{align*}
with 
    \begin{align*}
      I_\text{leak}(\text{Ca},\text{Ca}_\text{SR})
      &=V_\text{leak}\big(\text{Ca}_\text{SR} -\text{Ca}\big),\\
      I_\text{up}(\text{Ca})
      &=\frac{V_\text{maxup}}{1+K_\text{up}^2/\text{Ca}^2},\\
      I_\text{rel}(\text{Ca}_\text{SR},\text{Ca}_\text{SS},\bar{R})
      &=V_\text{rel}
      \bar{O}(\text{Ca}_\text{SS},\bar{R})\big(\text{Ca}_\text{SR}-\text{Ca}_\text{SS}\big),\\
      I_\text{xfer}(\text{Ca},\text{Ca}_\text{SS})
      &=V_\text{xfer}\big(\text{Ca}_\text{SS} -\text{Ca}\big)
      \,,
    \end{align*}
where the proportion of open $I_\text{rel}$ channels is given by 
    \begin{align*}
      \bar{O}(\text{Ca}_\text{SS},\bar{R})
      &=
      \frac{k_1\text{Ca}_\text{SS}^2\bar{R}}{k_3+k_1\text{Ca}_\text{SS}^2}
\end{align*}
depending on the proportion of closed $I_\text{rel}$ channels $\bar{R}$,
which is modeled by a Hodgkin-Huxley type equation 
      \begin{align*}
        \partial_t \bar{R}
        &=
        \alpha_{\bar{R}}(1-\bar{R}) - \beta_{\bar{R}}(\text{Ca}_\text{SS})\bar{R}
      \end{align*}
with
      \begin{align*}
        \alpha_{\bar{R}} = k_4\,,\qquad
        \beta_{\bar{R}}(\text{Ca}_\text{SS})
        =  k_2\text{Ca}_\text{SS}
        \,.
      \end{align*}    
      
\Paragraph{The gating mechanism}

Gating variables $y$ are described by a Hodgkin-Huxley type equation
    \begin{equation}\label{eq:gatingDifferentialgleichung}
      \partial_t y = \alpha_y(V_\text{m})(1-y) - \beta_y(V_\text{m}) y\,,
    \end{equation}
where $\alpha_y$ and $\beta_y$ are nonnegative functions of
$V_\text{m}$, cf.~\cite{croninHodgkin}. In case of constant
coefficients $\alpha_y$ and $\beta_y$, we obtain the solution of the linear ODE
    \begin{equation}
      \label{eq:y_update}
      y(t) = \frac{\alpha_y}{\alpha_y + \beta_y}
      -\Big(\frac{\alpha_y}{\alpha_y + \beta_y}-y(t_{n-1})\Big)
        \exp\big(-(\alpha_y + \beta_y)(t-t_{n-1})\big)\,,\qquad
        t\in [t_{n-1},t_n]
      \,.
    \end{equation}
This expression is used in the time-stepping scheme, i.e,
$y^n$ is computed from  $y^{n-1}$ with \eqref{eq:y_update} by inserting 
$\alpha_y^{n-1} = \alpha_y(V_\text{m}^{n-1})$ and $\beta_y^{n-1} = \beta_y(V_\text{m}^{n-1})$.

Thus, we specify directly 
     \begin{align*}
       \tau_y (V_\text{m})= \frac{1}{\alpha_y(V_\text{m}) + \beta_y(V_\text{m})}\,,\qquad
       y_\infty(V_\text{m}) =  \frac{\alpha_y(V_\text{m})}{\alpha_y(V_\text{m}) + \beta_y(V_\text{m})}
       \,,       
     \end{align*}
from which $\alpha_y(V_\text{m})$ and $\beta_y(V_\text{m})$ can be computed.

\Paragraph{The gating evolution in the ten Tusscher model}

In the following, all expressions depending on $V_\text{m}$ are given
in mV, i.e., in $\exp\big((35+V_\text{m})/5\big)$ the qualities 35 and 5
have the physical unit mV. The gating variables
$y \in\big\{m,h,j,x_\text{r1},x_\text{r2},x_\text{s},s,r,d,f,f_2\big\}$
are determined by
      \begin{align*}
        \tau_{m}(V_\text{m})
        &=
        \frac{1}{1+\exp\big((-60-V_\text{m})/5\big)}
        \Big(\frac{0.1}{1+\exp\big((35+V_\text{m})/5\big)}
        +\frac{0.1}{1+\exp\big((-50+V_\text{m}\big)/200)}\Big)
        \,,
        \\
        m_{\infty}(V_\text{m})
        &=
        \frac{1}{\Big(1+\exp\big((-56.86-V_\text{m})/9.03\big)\Big)^2}
        \,,
      \end{align*}
    \begin{align*}
      \tau_h(V_\text{m})
              \displaystyle
        &=\begin{cases} \frac{0.13(1+\exp\big(-(V_\text{m}+10.66)/11.1\big)\big)}{0.77}& V_\text{m}\geq -40\,, \\ 
        \Big(0.057\exp\big(-(V_\text{m}+80)/6.8\big) + 2.7\exp(0.079 V_\text{m})
          +3.1\cdot10^5\exp(0.3485 V_\text{m})\Big)^{-1} & \text{else}\,,
        \end{cases}        
        \\         
       h_{\infty}(V_\text{m})
               &=
        \frac{1}{\Big(1+\exp\big((71.55+V_\text{m})/7.43\big)\Big)^2}
        \,,
      \end{align*}

    \begin{align*}
      \tau_j(V_\text{m})
      &=
        \displaystyle
      \begin{cases} \frac{1+\exp(-0.1(V_\text{m}+32))}{0.6\exp(0.057 V_\text{m})} & V_\text{m}\geq -40 \,,\\
        %\begin{split}
        \Bigg(\frac{
             \big(-2.5428\cdot 10^4\exp(0.24444 V_\text{m})
          -
            6.948\cdot 10^{-6}\exp(-0.04391 V_\text{m})\big)(V_\text{m}+37.78)}
               {1+\exp(0.311(V_\text{m}+79.23))} %\\
               +\frac{0.02424\exp(-0.01052 V_\text{m})}{1+\exp(-0.1378(V_\text{m}+40.14))}\Bigg)^{-1} 
               %\end{split} 
               & \text{else}\,,
        \end{cases}
        \\
        j_{\infty}(V_\text{m})
        &=
        h_{\infty}(V_\text{m})\,.
    \end{align*}

    \begin{align*}
        \tau_d(V_\text{m})
          &=
          \Big(\frac{1.4}{1+\exp\big((-35-V_\text{m})/13\big)}+0.25\Big)
          \frac{1.4}{1+\exp\big((5+V_\text{m})/5\big)}
          + \frac{1}{1+\exp\big((50-V_\text{m})/20\big)}
          \,,\\
          d_{\infty}(V_\text{m})
          &=
          \frac{1}{1+\exp\big((-8-V_\text{m})/7.5\big)}
          \,,
      \end{align*}

    \begin{align*}
          \tau_f(V_\text{m})
          &=
          1102.5\exp\Big(-\Big(\frac{V_\text{m}+27}{15}\Big)^2\Big)
          +  \frac{200}{1+\exp\big((13-V_\text{m})/10\big)}
          +   \frac{180}{1+\exp\big((30+V_\text{m})/10\big)} + 20
          \,,\\
          f_{\infty}(V_\text{m})
          &=
         \frac{1}{1+\exp\big((20+V_\text{m})/7\big)}
         \,,
             \end{align*}

    \begin{align*}
          \tau_{f_2}(V_\text{m})
          &=
          600\exp\Big(-\frac{(V_\text{m}+25)^2}{170}\Big)
          +\frac{31}{1+\exp\big((25-V_\text{m})/10\big)}
          +\frac{16}{1+\exp\big((30+V_\text{m})/10\big)}
          \,,\\
          f_{2,\infty}(V_\text{m})
          &=
            \frac{0.67}{1+\exp\big((35+V_\text{m})/7\big)} + 0.33
          \,,
    \end{align*}
    
          \begin{align*}
      \tau_{x_\text{s}}(V_\text{m})
          &=
          \frac{1400}{\sqrt{1+\exp\big((5-V_\text{m})/6\big)}} \frac{1}{1+\exp\big((-35+V_\text{m})/15\big)}
          + 80
          \,,\\
          x_{\text{s},\infty}(V_\text{m})
          &=
          \frac{1}{1+\exp\big((-5-V_\text{m})/14\big)}
          \,,
              \end{align*}

    \begin{align*}
          \tau_r(V_\text{m})
          &=
          9.5\exp\Big(-\frac{(40+V_\text{m})^2}{1800}\Big)+0.8
          \,,\\
          r_{\infty}(V_\text{m})
          &=
          \frac{1}{1+\exp\big((20-V_\text{m})/6\big)}
          \,,
              \end{align*}

    \begin{align*}
           \tau_s(V_\text{m})
          &=
          85\exp\Big(-\frac{(45+V_\text{m})^2}{320}\Big) 
          + \frac{5}{1+\exp\big((-20+V_\text{m})/5\big)} +3
          \,,\\
          s_{\infty}(V_\text{m})
          &=
          \frac{1}{1+\exp\big((20+V_\text{m})/5\big)}
          \,,
              \end{align*}

    \begin{align*}
          \tau_{x_\text{r1}}(V_\text{m})
          &=
          \frac{450}{1+\exp\big((-45-V_\text{m})/10\big)}
          \frac{6}{1+\exp\big((30+V_\text{m})/11.5\big)}
          \,,\\
          x_{\text{r1},\infty}(V_\text{m})
          &=
          \frac{1}{1+\exp\big((-26-V_\text{m})/7\big)}
          \,,
              \end{align*}

    \begin{align*}
          \tau_{x_\text{r2}}(V_\text{m})
          &=
          \frac{3}{1+\exp\big((-60-V_\text{m})/20\big)}
          \frac{1.12}{1+\exp\big((-60+V_\text{m})/20\big)}
          \,,\\
          x_{\text{r2},\infty}(V_\text{m})
          &=
          \frac{1}{1+\exp\big((88+V_\text{m})/24\big)}
          \,.
      \end{align*}    
The evolution of the gating variable $f_\text{Ca}$ is also 
given by a Hodgkin-Huxley type equation, depending on~$\text{Ca}_\text{ss}$. We have
    \begin{align*}
      \tau_{f_\text{Ca}}(\text{Ca}_\text{ss})
      =
      \frac{80}{1+\big(\frac{\text{Ca}_\text{ss}}{0.05}\big)^2} + 2
      \,,\qquad
      f_{\text{Ca},\infty}(\text{Ca}_\text{ss})
      =
      \frac{0.6}{1+\big(\frac{\text{Ca}_\text{ss}}{0.05}\big)^2} + 0.4
      \,.
    \end{align*}
\Paragraph{Computing $\alpha(V_\text{m})$ and $\beta(V_\text{m})$}
In the cell model of ten Tusscher we have 11 variables to describe the gating mechanism. For two of them we know $\alpha(V_\text{m})$ and $\beta(V_\text{m})$ from definition. For all others we have to compute the values if we want to know them. For the implemented numerical method the exact integrators it is sufficient to know $\tau_x$ and $x_{\infty}$. To use another numerical scheme we need the values of $\alpha(V_\text{m})$ and $\beta(V_\text{m})$. For a fixed potential $V$ we have $\tau_x:=\tau_x(V)$ and $x_{\infty}:=x_{\infty}(V)$. With those we want to compute $\alpha :=\alpha(V)$ and $\beta:=\beta(V)$. To repeat shortly we know
\begin{eqnarray*}
\tau_x= \frac{1}{\alpha+\beta}\\
x_{\infty}= \frac{\alpha}{\alpha+\beta}.
\end{eqnarray*}
Then 
\begin{eqnarray*}
x_{\infty} = \alpha\tau_x  \Leftrightarrow \alpha = \frac{x_{\infty}}{\tau_x} 
\end{eqnarray*}
and for $\beta$ we have
\begin{eqnarray*}
\tau_x= \frac{1}{\alpha+\beta} \Leftrightarrow \tau_x(\alpha+\beta)=1 \Leftrightarrow \beta=\frac{1}{\tau_x}-\alpha.
\end{eqnarray*}
Inserting $\alpha$ gives
\begin{eqnarray*}
 \beta=\frac{1}{\tau_x}-\frac{x_{\infty}}{\tau_x} = \frac{1-x_{\infty}}{\tau_x}.
\end{eqnarray*}